Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 58543)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 58544)
@@ -136,5 +136,5 @@
 const char* UIExtraDataDefs::GUI_RealtimeDockIconUpdateEnabled = "GUI/RealtimeDockIconUpdateEnabled";
 const char* UIExtraDataDefs::GUI_RealtimeDockIconUpdateMonitor = "GUI/RealtimeDockIconUpdateMonitor";
-const char* UIExtraDataDefs::GUI_DockIconOverlayEnabled = "GUI/DockIconOverlayEnabled";
+const char* UIExtraDataDefs::GUI_DockIconOverlayDisabled = "GUI/DockIconOverlayDisabled";
 #endif /* Q_WS_MAC */
 const char* UIExtraDataDefs::GUI_PassCAD = "GUI/PassCAD";
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 58543)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 58544)
@@ -235,6 +235,6 @@
         /** Mac OS X: Holds guest-screen which Dock icon should reflect at runtime. */
         extern const char* GUI_RealtimeDockIconUpdateMonitor;
-        /** Mac OS X: Holds whether Dock icon should have guest-os overlay. */
-        extern const char* GUI_DockIconOverlayEnabled;
+        /** Mac OS X: Holds whether Dock icon should disable guest-os overlay. */
+        extern const char* GUI_DockIconOverlayDisabled;
 #endif /* Q_WS_MAC */
         /** Holds whether machine should pass CAD to guest. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 58543)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 58544)
@@ -1874,5 +1874,5 @@
            << GUI_StatusBar_Enabled << GUI_RestrictedStatusBarIndicators << GUI_StatusBar_IndicatorOrder
 #ifdef Q_WS_MAC
-           << GUI_RealtimeDockIconUpdateEnabled << GUI_RealtimeDockIconUpdateMonitor << GUI_DockIconOverlayEnabled
+           << GUI_RealtimeDockIconUpdateEnabled << GUI_RealtimeDockIconUpdateMonitor << GUI_DockIconOverlayDisabled
 #endif /* Q_WS_MAC */
            << GUI_PassCAD
@@ -3431,14 +3431,14 @@
 }
 
-bool UIExtraDataManager::dockIconOverlayEnabled(const QString &strID)
-{
-    /* 'True' unless feature restricted: */
-    return !isFeatureRestricted(GUI_DockIconOverlayEnabled, strID);
-}
-
-void UIExtraDataManager::setdockIconOverlayEnabled(bool fEnabled, const QString &strID)
-{
-    /* 'False' if feature restricted, 'True' otherwise: */
-    setExtraDataString(GUI_DockIconOverlayEnabled, toFeatureRestricted(!fEnabled), strID);
+bool UIExtraDataManager::dockIconOverlayDisabled(const QString &strID)
+{   
+    /* 'False' unless feature allowed: */
+    return isFeatureAllowed(GUI_DockIconOverlayDisabled, strID);
+}
+
+void UIExtraDataManager::setdockIconOverlayDisabled(bool fDisabled, const QString &strID)
+{
+    /* 'True' if feature allowed, null-string otherwise: */
+    setExtraDataString(GUI_DockIconOverlayDisabled, toFeatureAllowed(fDisabled), strID);
 }
 #endif /* Q_WS_MAC */
@@ -3826,6 +3826,6 @@
                 emit sigDockIconAppearanceChange(!isFeatureRestricted(strKey, strMachineID));
             /* 'Dock icon overlay' appearance changed (allowed if not restricted)? */
-            else if (strKey == GUI_DockIconOverlayEnabled)
-                emit sigDockIconOverlayAppearanceChange(!isFeatureRestricted(strKey, strMachineID));
+            else if (strKey == GUI_DockIconOverlayDisabled)
+                emit sigDockIconOverlayAppearanceChange(isFeatureAllowed(strKey, strMachineID));
 #endif /* Q_WS_MAC */
         }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 58543)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 58544)
@@ -463,8 +463,8 @@
         void setRealtimeDockIconUpdateMonitor(int iIndex, const QString &strID);
 
-        /** Mac OS X: Returns whether Dock icon overlay is enabled. */
-        bool dockIconOverlayEnabled(const QString &strID);
-        /** Mac OS X: Defines whether Dock icon overlay @a fEnabled. */
-        void setdockIconOverlayEnabled(bool fEnabled, const QString &strID);
+        /** Mac OS X: Returns whether Dock icon overlay is disabled. */
+        bool dockIconOverlayDisabled(const QString &strID);
+        /** Mac OS X: Defines whether Dock icon overlay @a fDisabled. */
+        void setdockIconOverlayDisabled(bool fDisabled, const QString &strID);
 #endif /* Q_WS_MAC */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/UIAbstractDockIconPreview.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/UIAbstractDockIconPreview.cpp	(revision 58543)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/UIAbstractDockIconPreview.cpp	(revision 58544)
@@ -121,6 +121,6 @@
 void UIAbstractDockIconPreviewHelper::drawOverlayIcons(CGContextRef context)
 {
-    /* Determine whether dock icon overlay enabled: */
-    if (gEDataManager->dockIconOverlayEnabled(vboxGlobal().managedVMUuid()))
+    /* Determine whether dock icon overlay is not disabled: */
+    if (!gEDataManager->dockIconOverlayDisabled(vboxGlobal().managedVMUuid()))
     {
         /* Initialize overlayrect: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 58543)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 58544)
@@ -2131,8 +2131,8 @@
 }
 
-void UIMachineLogic::sltChangeDockIconOverlayAppearance(bool fEnabled)
+void UIMachineLogic::sltChangeDockIconOverlayAppearance(bool fDisabled)
 {
     /* Value of flag is directly referenced from extra-data manager later: */
-    Q_UNUSED(fEnabled);
+    Q_UNUSED(fDisabled);
     /* Update dock icon overlay: */
     if (isMachineWindowsCreated())
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.h	(revision 58543)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.h	(revision 58544)
@@ -311,5 +311,6 @@
     void sltDockPreviewMonitorChanged(QAction *pAction);
     void sltChangeDockIconUpdate(bool fEnabled);
-    void sltChangeDockIconOverlayAppearance(bool fEnabled);
+    /** Handles dock icon overlay change event. */
+    void sltChangeDockIconOverlayAppearance(bool fDisabled);
 #endif /* RT_OS_DARWIN */
 
@@ -397,4 +398,6 @@
     QActionGroup *m_pDockPreviewSelectMonitorGroup;
     int m_DockIconPreviewMonitor;
+    /** Holds whether dock icon overlay disabled. */
+    bool m_fIsDockIconOverlayDisabled;
 #endif /* Q_WS_MAC */
 