Index: /trunk/src/VBox/Installer/win/UserInterface.wxi
===================================================================
--- /trunk/src/VBox/Installer/win/UserInterface.wxi	(revision 58553)
+++ /trunk/src/VBox/Installer/win/UserInterface.wxi	(revision 58554)
@@ -394,13 +394,13 @@
                  Also see: http://osdir.com/ml/windows.devel.wix.user/2005-02/msg00300.html -->
             <Control Id="DesktopShortcutCheckBox" Type="CheckBox" X="25" Y="95" Width="200" Height="17"
-                Property="VBOX_INSTALLDESKTOPSHORTCUT" CheckBoxValue="1">
+                Property="VBOXINSTALLDESKTOPSHORTCUT" CheckBoxValue="1">
                 <Text>!(loc.Customize2Dlg_CreateShortcut)</Text>
             </Control>
             <Control Id="QuicklaunchShortcutCheckBox" Type="CheckBox" X="25" Y="115" Width="200" Height="17"
-                     Property="VBOX_INSTALLQUICKLAUNCHSHORTCUT" CheckBoxValue="1">
+                     Property="VBOXINSTALLQUICKLAUNCHSHORTCUT" CheckBoxValue="1">
                 <Text>!(loc.Customize2Dlg_CreateQuickLaunch)</Text>
             </Control>
             <Control Id="RegisterFileExtensionsCheckBox" Type="CheckBox" X="25" Y="135" Width="200" Height="17"
-                     Property="VBOX_REGISTERFILEEXTENSIONS" CheckBoxValue="1">
+                     Property="VBOXREGISTERFILEEXTENSIONS" CheckBoxValue="1">
                 <Text>!(loc.Customize2Dlg_RegisterFileExtensions)</Text>
             </Control>
@@ -586,5 +586,5 @@
         <Dialog Id="VBoxExitDlg" Width="370" Height="270" Title="[ProductName] !(loc.Setup)" NoMinimize="yes">
             <Control Id="Finish" Type="PushButton" X="236" Y="243" Width="56" Height="17" Default="yes" Cancel="yes" Text="!(loc.ButtonText_Finish)">
-                <Publish Event="DoAction" Value="ca_StartVBox"><![CDATA[VBOX_STARTVBOX]]></Publish>
+                <Publish Event="DoAction" Value="ca_StartVBox"><![CDATA[VBOXSTART]]></Publish>
                 <Publish Event="EndDialog" Value="Return">1</Publish>
             </Control>
@@ -610,5 +610,5 @@
                  Also see: http://osdir.com/ml/windows.devel.wix.user/2005-02/msg00300.html -->
             <Control Id="StartVBoxCheckBox" Type="CheckBox" X="135" Y="115" Width="200" Height="17"
-                Property="VBOX_STARTVBOX" CheckBoxValue="1">
+                Property="VBOXSTART" CheckBoxValue="1">
                 <Text>!(loc.ExitDlg_StartVBox)</Text>
                 <Condition Action="hide">
Index: /trunk/src/VBox/Installer/win/VirtualBox.wxs
===================================================================
--- /trunk/src/VBox/Installer/win/VirtualBox.wxs	(revision 58553)
+++ /trunk/src/VBox/Installer/win/VirtualBox.wxs	(revision 58554)
@@ -74,8 +74,8 @@
 
     <!-- VirtualBox properties -->
-    <Property Id="VBOX_INSTALLDESKTOPSHORTCUT" Value="1" />
-    <Property Id="VBOX_INSTALLQUICKLAUNCHSHORTCUT" Value="1" />
-    <Property Id="VBOX_REGISTERFILEEXTENSIONS" Value="1" />
-    <Property Id="VBOX_STARTVBOX" Value="1" />
+    <Property Id="VBOXINSTALLDESKTOPSHORTCUT" Value="1" />
+    <Property Id="VBOXINSTALLQUICKLAUNCHSHORTCUT" Value="1" />
+    <Property Id="VBOXREGISTERFILEEXTENSIONS" Value="1" />
+    <Property Id="VBOXSTART" Value="1" />
 
     <!-- Make sure installation will not start on anything other but the NT family -->
@@ -108,5 +108,5 @@
     </Condition>
 
-    
+
     <!-- *************************** Upgrade packages only ******************************* -->
     <!-- Minimum and Maximum specify the range of versions we are supposed to update with this upgrade.
@@ -170,5 +170,5 @@
         </DirectorySearch>
     </Property>
-    
+
     <!--
                             install upgrade uninstall
@@ -179,10 +179,10 @@
     -->
 
-    <Condition Message="It was detected an application which has been using currently installed VirtualBox version. 
-    You must remove this application before continuing installation. 
+    <Condition Message="It was detected an application which has been using currently installed VirtualBox version.
+    You must remove this application before continuing installation.
     See the file dependency.dep in the VirtualBox installation directory for details. ">
         NOT (VBOXDEPENDENCY AND UPGRADINGPRODUCTCODE)
     </Condition>
-    
+
     <!-- Detect old Sun installation -->
     <!-- Force a manual uninstall of an already installed Sun VirtualBox version first -->
@@ -331,5 +331,5 @@
 
                 <Component Id="cp_DesktopShortcut" Guid="668F8A1A-F5CE-48B3-BB1A-3042EE27B279" Win64="$(var.Property_Win64)">
-                    <Condition>VBOX_INSTALLDESKTOPSHORTCUT</Condition>
+                    <Condition>VBOXINSTALLDESKTOPSHORTCUT</Condition>
                     <Shortcut Id="sc_DesktopVBox" Directory="DesktopFolder" Name="$(env.VBOX_PRODUCT)" Description="$(env.VBOX_PRODUCT)"
                               Target="[INSTALLDIR]VirtualBox.exe" WorkingDirectory="INSTALLDIR"/>
@@ -340,5 +340,5 @@
                 <Component Id="cp_QuickLaunchVBox" Guid="CC19E026-938A-41CB-8E77-3F33296244B6" Win64="$(var.Property_Win64)">
                     <CreateFolder/>
-                    <Condition>VBOX_INSTALLQUICKLAUNCHSHORTCUT</Condition>
+                    <Condition>VBOXINSTALLQUICKLAUNCHSHORTCUT</Condition>
                     <Shortcut Id="sc_QuickLaunchVBox" Directory="dir_QuicklaunchFolder" Name="$(env.VBOX_PRODUCT)" Description="$(env.VBOX_PRODUCT)"
                               Target="[INSTALLDIR]VirtualBox.exe" WorkingDirectory="INSTALLDIR"/>
@@ -439,9 +439,9 @@
                 <MergeRef Id="msm_VBoxNetworkAdp" />
                 <MergeRef Id="msm_VBoxNetworkAdp6" />
-                <MergeRef Id="msm_VBoxNetworkLwf" />                
+                <MergeRef Id="msm_VBoxNetworkLwf" />
     <?else ?>
                 <ComponentRef Id="cp_NetAdpDriver" />
                 <ComponentRef Id="cp_NetAdp6Driver" />
-                <ComponentRef Id="cp_NetLwfDriver" />                
+                <ComponentRef Id="cp_NetLwfDriver" />
     <?endif ?>
             </Feature>