Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 58673)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 58674)
@@ -136,5 +136,5 @@
 const char* UIExtraDataDefs::GUI_RealtimeDockIconUpdateEnabled = "GUI/RealtimeDockIconUpdateEnabled";
 const char* UIExtraDataDefs::GUI_RealtimeDockIconUpdateMonitor = "GUI/RealtimeDockIconUpdateMonitor";
-const char* UIExtraDataDefs::GUI_DockIconOverlayDisabled = "GUI/DockIconOverlayDisabled";
+const char* UIExtraDataDefs::GUI_DockIconDisableOverlay = "GUI/DockIconDisableOverlay";
 #endif /* Q_WS_MAC */
 const char* UIExtraDataDefs::GUI_PassCAD = "GUI/PassCAD";
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 58673)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 58674)
@@ -235,6 +235,6 @@
         /** Mac OS X: Holds guest-screen which Dock icon should reflect at runtime. */
         extern const char* GUI_RealtimeDockIconUpdateMonitor;
-        /** Mac OS X: Holds whether Dock icon should disable guest-os overlay. */
-        extern const char* GUI_DockIconOverlayDisabled;
+        /** Mac OS X: Holds whether Dock icon should have overlay disabled. */
+        extern const char* GUI_DockIconDisableOverlay;
 #endif /* Q_WS_MAC */
         /** Holds whether machine should pass CAD to guest. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 58673)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 58674)
@@ -1874,5 +1874,5 @@
            << GUI_StatusBar_Enabled << GUI_RestrictedStatusBarIndicators << GUI_StatusBar_IndicatorOrder
 #ifdef Q_WS_MAC
-           << GUI_RealtimeDockIconUpdateEnabled << GUI_RealtimeDockIconUpdateMonitor << GUI_DockIconOverlayDisabled
+           << GUI_RealtimeDockIconUpdateEnabled << GUI_RealtimeDockIconUpdateMonitor << GUI_DockIconDisableOverlay
 #endif /* Q_WS_MAC */
            << GUI_PassCAD
@@ -3431,14 +3431,14 @@
 }
 
-bool UIExtraDataManager::dockIconOverlayDisabled(const QString &strID)
-{   
+bool UIExtraDataManager::dockIconDisableOverlay(const QString &strID)
+{
     /* 'False' unless feature allowed: */
-    return isFeatureAllowed(GUI_DockIconOverlayDisabled, strID);
-}
-
-void UIExtraDataManager::setdockIconOverlayDisabled(bool fDisabled, const QString &strID)
+    return isFeatureAllowed(GUI_DockIconDisableOverlay, strID);
+}
+
+void UIExtraDataManager::setDockIconDisableOverlay(bool fDisabled, const QString &strID)
 {
     /* 'True' if feature allowed, null-string otherwise: */
-    setExtraDataString(GUI_DockIconOverlayDisabled, toFeatureAllowed(fDisabled), strID);
+    setExtraDataString(GUI_DockIconDisableOverlay, toFeatureAllowed(fDisabled), strID);
 }
 #endif /* Q_WS_MAC */
@@ -3825,6 +3825,6 @@
                      strKey == GUI_RealtimeDockIconUpdateMonitor)
                 emit sigDockIconAppearanceChange(!isFeatureRestricted(strKey, strMachineID));
-            /* 'Dock icon overlay' appearance changed (allowed if not restricted)? */
-            else if (strKey == GUI_DockIconOverlayDisabled)
+            /* 'Dock icon overlay' appearance changed (restricted if not allowed)? */
+            else if (strKey == GUI_DockIconDisableOverlay)
                 emit sigDockIconOverlayAppearanceChange(isFeatureAllowed(strKey, strMachineID));
 #endif /* Q_WS_MAC */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 58673)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 58674)
@@ -464,7 +464,7 @@
 
         /** Mac OS X: Returns whether Dock icon overlay is disabled. */
-        bool dockIconOverlayDisabled(const QString &strID);
-        /** Mac OS X: Defines whether Dock icon overlay @a fDisabled. */
-        void setdockIconOverlayDisabled(bool fDisabled, const QString &strID);
+        bool dockIconDisableOverlay(const QString &strID);
+        /** Mac OS X: Defines whether Dock icon overlay is @a fDisabled. */
+        void setDockIconDisableOverlay(bool fDisabled, const QString &strID);
 #endif /* Q_WS_MAC */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/UIAbstractDockIconPreview.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/UIAbstractDockIconPreview.cpp	(revision 58673)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/UIAbstractDockIconPreview.cpp	(revision 58674)
@@ -122,7 +122,7 @@
 {
     /* Determine whether dock icon overlay is not disabled: */
-    if (!gEDataManager->dockIconOverlayDisabled(vboxGlobal().managedVMUuid()))
+    if (!gEDataManager->dockIconDisableOverlay(vboxGlobal().managedVMUuid()))
     {
-        /* Initialize overlayrect: */
+        /* Initialize overlay rectangle: */
         CGRect overlayRect = CGRectMake(0, 0, 0, 0);
         /* Make sure overlay image is valid: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 58673)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 58674)
@@ -1840,11 +1840,11 @@
 };
 
-class UIActionToggleDockIconOverlayDisabled : public UIActionToggle
-{
-    Q_OBJECT;
-
-public:
-
-    UIActionToggleDockIconOverlayDisabled(UIActionPool *pParent)
+class UIActionToggleDockIconDisableOverlay : public UIActionToggle
+{
+    Q_OBJECT;
+
+public:
+
+    UIActionToggleDockIconDisableOverlay(UIActionPool *pParent)
         : UIActionToggle(pParent) {}
 
@@ -2149,5 +2149,5 @@
     m_pool[UIActionIndexRT_M_Dock_M_DockSettings_T_PreviewMonitor] = new UIActionToggleDockPreviewMonitor(this);
     m_pool[UIActionIndexRT_M_Dock_M_DockSettings_T_DisableMonitor] = new UIActionToggleDockDisableMonitor(this);
-    m_pool[UIActionIndexRT_M_Dock_M_DockSettings_T_OverlayDisabled] = new UIActionToggleDockIconOverlayDisabled(this);
+    m_pool[UIActionIndexRT_M_Dock_M_DockSettings_T_DisableOverlay] = new UIActionToggleDockIconDisableOverlay(this);
 #endif /* Q_WS_MAC */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.h	(revision 58673)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.h	(revision 58674)
@@ -122,5 +122,5 @@
     UIActionIndexRT_M_Dock_M_DockSettings_T_PreviewMonitor,
     UIActionIndexRT_M_Dock_M_DockSettings_T_DisableMonitor,
-    UIActionIndexRT_M_Dock_M_DockSettings_T_OverlayDisabled,
+    UIActionIndexRT_M_Dock_M_DockSettings_T_DisableOverlay,
 #endif /* Q_WS_MAC */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 58673)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 58674)
@@ -1194,15 +1194,15 @@
             this, SLOT(sltChangeDockIconUpdate(bool)));
 
-    /* Get dock icon overlay disabled action: */
-    QAction *pDockIconOverlayDisabled = actionPool()->action(UIActionIndexRT_M_Dock_M_DockSettings_T_OverlayDisabled);
-    /* Prepare dock icon overlay disabled action with initial data: */
-    pDockIconOverlayDisabled->setChecked(gEDataManager->dockIconOverlayDisabled(vboxGlobal().managedVMUuid()));
-    /* Connect dock icon overlay disabled signals: */
-    connect(pDockIconOverlayDisabled, SIGNAL(triggered(bool)),
-            this, SLOT(sltDockIconOverlayDisabledChanged(bool)));
+    /* Get dock icon disable overlay action: */
+    QAction *pDockIconDisableOverlay = actionPool()->action(UIActionIndexRT_M_Dock_M_DockSettings_T_DisableOverlay);
+    /* Prepare dock icon disable overlay action with initial data: */
+    pDockIconDisableOverlay->setChecked(gEDataManager->dockIconDisableOverlay(vboxGlobal().managedVMUuid()));
+    /* Connect dock icon disable overlay related signals: */
+    connect(pDockIconDisableOverlay, SIGNAL(triggered(bool)),
+            this, SLOT(sltDockIconDisableOverlayChanged(bool)));
     connect(gEDataManager, SIGNAL(sigDockIconOverlayAppearanceChange(bool)),
             this, SLOT(sltChangeDockIconOverlayAppearance(bool)));
-    /* Add dock icon overlay disabled action to the dock settings menu: */
-    pDockSettingsMenu->addAction(pDockIconOverlayDisabled);
+    /* Add dock icon disable overlay action to the dock settings menu: */
+    pDockSettingsMenu->addAction(pDockIconDisableOverlay);
 
     /* Monitor selection if there are more than one monitor */
@@ -2143,19 +2143,24 @@
 void UIMachineLogic::sltChangeDockIconOverlayAppearance(bool fDisabled)
 {
-    /* Value of flag is directly referenced from extra-data manager later: */
-    Q_UNUSED(fDisabled);
     /* Update dock icon overlay: */
     if (isMachineWindowsCreated())
         updateDockOverlay();
-    /* Make sure to update dock icon action when dock icon overlay disabled changed from extra-data manager: */
-    QAction *pDockIconOverlayDisabled = actionPool()->action(UIActionIndexRT_M_Dock_M_DockSettings_T_OverlayDisabled);
-    if (fDisabled != pDockIconOverlayDisabled->isChecked())
-        pDockIconOverlayDisabled->setChecked(fDisabled);
-}
-
-void UIMachineLogic::sltDockIconOverlayDisabledChanged(bool fDisabled)
-{
-    /* Write dock icon overlay flag to extra-data: */
-    gEDataManager->setdockIconOverlayDisabled(fDisabled, vboxGlobal().managedVMUuid());
+    /* Make sure to update dock icon disable overlay action state when 'GUI_DockIconDisableOverlay' changed from extra-data manager: */
+    QAction *pDockIconDisableOverlay = actionPool()->action(UIActionIndexRT_M_Dock_M_DockSettings_T_DisableOverlay);
+    if (fDisabled != pDockIconDisableOverlay->isChecked())
+    {
+        /* Block signals initially to avoid recursive loop: */
+        pDockIconDisableOverlay->blockSignals(true);
+        /* Update state: */
+        pDockIconDisableOverlay->setChecked(fDisabled);
+        /* Make sure to unblock signals again: */
+        pDockIconDisableOverlay->blockSignals(false);
+    }
+}
+
+void UIMachineLogic::sltDockIconDisableOverlayChanged(bool fDisabled)
+{
+    /* Write dock icon disable overlay flag to extra-data: */
+    gEDataManager->setDockIconDisableOverlay(fDisabled, vboxGlobal().managedVMUuid());
 }
 #endif /* Q_WS_MAC */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.h	(revision 58673)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.h	(revision 58674)
@@ -314,5 +314,5 @@
     void sltChangeDockIconOverlayAppearance(bool fDisabled);
     /** Handles dock icon overlay disable action triggering. */
-    void sltDockIconOverlayDisabledChanged(bool fDisabled);
+    void sltDockIconDisableOverlayChanged(bool fDisabled);
 #endif /* RT_OS_DARWIN */
 
@@ -400,6 +400,4 @@
     QActionGroup *m_pDockPreviewSelectMonitorGroup;
     int m_DockIconPreviewMonitor;
-    /** Holds whether dock icon overlay disabled. */
-    bool m_fIsDockIconOverlayDisabled;
 #endif /* Q_WS_MAC */
 