Index: /trunk/src/VBox/Frontends/VirtualBox/src/UIVMLogViewer.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/UIVMLogViewer.cpp	(revision 58858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/UIVMLogViewer.cpp	(revision 58859)
@@ -57,8 +57,9 @@
 
     /** Constructs search-panel by passing @a pParent to the QWidget base-class constructor.
-      * @a pViewer is the instance of VM Log-Viewer. */
+      * @param  pViewer  Specifies instance of VM Log-Viewer. */
     UIVMLogViewerSearchPanel(QWidget *pParent, UIVMLogViewer *pViewer)
         : QIWithRetranslateUI<QWidget>(pParent)
         , m_pViewer(pViewer)
+        , m_pMainLayout(0)
         , m_pCloseButton(0)
         , m_pSearchLabel(0), m_pSearchEditor(0)
@@ -74,5 +75,5 @@
 
     /** Handles find next/back action triggering.
-      * @a iButton specifies id of next/back button. */
+      * @param  iButton  Specifies id of next/back button. */
     void find(int iButton)
     {
@@ -84,5 +85,5 @@
 
     /** Handles textchanged event from search-editor.
-      * @a strSearchString specifies the search-string. */
+      * @param  strSearchString  Specifies search-string. */
     void findCurrent(const QString &strSearchString)
     {
@@ -109,10 +110,10 @@
     void prepare()
     {
+        /* Prepare main-layout: */
+        prepareMainLayout();
+
         /* Prepare widgets: */
         prepareWidgets();
 
-        /* Prepare main-layout: */
-        prepareMainLayout();
-
         /* Prepare connections: */
         prepareConnections();
@@ -120,4 +121,18 @@
         /* Retranslate finally: */
         retranslateUi();
+    }
+
+    /** Prepares main-layout. */
+    void prepareMainLayout()
+    {
+        /* Create main-layout: */
+        m_pMainLayout = new QHBoxLayout(this);
+        AssertPtrReturnVoid(m_pMainLayout);
+        {
+            /* Prepare main-layout: */
+            m_pMainLayout->setSpacing(5);
+            /* Not sure 0 margins are default, but just to be safe: */
+            m_pMainLayout->setContentsMargins(0, 0, 0, 0);
+        }
     }
 
@@ -128,87 +143,110 @@
         m_pCloseButton = new UIMiniCancelButton(this);
         AssertPtrReturnVoid(m_pCloseButton);
+        {
+            /* Add close-button to main-layout: */
+            m_pMainLayout->addWidget(m_pCloseButton);
+        }
 
         /* Create search-editor: */
         m_pSearchEditor = new UISearchField(this);
         AssertPtrReturnVoid(m_pSearchEditor);
-        /* Prepare search-editor: */
-        m_pSearchEditor->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);
+        {
+            /* Configure search-editor: */
+            m_pSearchEditor->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);
+            /* Add search-editor to main-layout: */
+            m_pMainLayout->addWidget(m_pSearchEditor);
+        }
 
         /* Create search-label: */
         m_pSearchLabel = new QLabel(this);
         AssertPtrReturnVoid(m_pSearchLabel);
-        /* Prepare search-label: */
-        m_pSearchLabel->setBuddy(m_pSearchEditor);
+        {
+            /* Configure search-label: */
+            m_pSearchLabel->setBuddy(m_pSearchEditor);
+            /* Prepare font: */
+#ifdef VBOX_DARWIN_USE_NATIVE_CONTROLS
+            QFont font = m_pSearchLabel->font();
+            font.setPointSize(::darwinSmallFontSize());
+            m_pSearchLabel->setFont(font);
+#endif /* VBOX_DARWIN_USE_NATIVE_CONTROLS */
+            /* Add search-label to main-layout: */
+            m_pMainLayout->addWidget(m_pSearchLabel);
+        }
 
         /* Create Next/Prev button-box: */
         m_pNextPrevButtons = new UIRoundRectSegmentedButton(this, 2);
         AssertPtrReturnVoid(m_pNextPrevButtons);
-        /* Prepare Next/Prev button-box: */
-        m_pNextPrevButtons->setEnabled(0, false);
-        m_pNextPrevButtons->setEnabled(1, false);
+        {
+            /* Prepare Next/Prev button-box: */
+            m_pNextPrevButtons->setEnabled(0, false);
+            m_pNextPrevButtons->setEnabled(1, false);
 #ifndef Q_WS_MAC
-        /* No icons on the Mac: */
-        m_pNextPrevButtons->setIcon(0, UIIconPool::defaultIcon(UIIconPool::UIDefaultIconType_ArrowBack, this));
-        m_pNextPrevButtons->setIcon(1, UIIconPool::defaultIcon(UIIconPool::UIDefaultIconType_ArrowForward, this));
+            /* No icons on the Mac: */
+            m_pNextPrevButtons->setIcon(0, UIIconPool::defaultIcon(UIIconPool::UIDefaultIconType_ArrowBack, this));
+            m_pNextPrevButtons->setIcon(1, UIIconPool::defaultIcon(UIIconPool::UIDefaultIconType_ArrowForward, this));
 #endif /* !Q_WS_MAC */
+            /* Add Next/Prev button-box to main-layout: */
+            m_pMainLayout->addWidget(m_pNextPrevButtons);
+        }
 
         /* Create case-sensitive checkbox: */
         m_pCaseSensitiveCheckBox = new QCheckBox(this);
         AssertPtrReturnVoid(m_pCaseSensitiveCheckBox);
-        /* Setup focus proxy: */
-        setFocusProxy(m_pCaseSensitiveCheckBox);
+        {
+            /* Configure focus for case-sensitive checkbox: */
+            setFocusProxy(m_pCaseSensitiveCheckBox);
+            /* Prepare font: */
+#ifdef VBOX_DARWIN_USE_NATIVE_CONTROLS
+            QFont font = m_pCaseSensitiveCheckBox->font();
+            font.setPointSize(::darwinSmallFontSize());
+            m_pCaseSensitiveCheckBox->setFont(font);
+#endif /* VBOX_DARWIN_USE_NATIVE_CONTROLS */
+            /* Add case-sensitive checkbox to main-layout: */
+            m_pMainLayout->addWidget(m_pCaseSensitiveCheckBox);
+        }
 
         /* Create warning-spacer: */
         m_pWarningSpacer = new QSpacerItem(0, 0, QSizePolicy::Fixed, QSizePolicy::Minimum);
         AssertPtrReturnVoid(m_pWarningSpacer);
+        {
+            /* Add warning-spacer to main-layout: */
+            m_pMainLayout->addItem(m_pWarningSpacer);
+        }
 
         /* Create warning-icon: */
         m_pWarningIcon = new QLabel(this);
         AssertPtrReturnVoid(m_pWarningIcon);
-        /* Prepare warning-icon: */
-        m_pWarningIcon->hide();
-        QIcon icon = UIIconPool::defaultIcon(UIIconPool::UIDefaultIconType_MessageBoxWarning, this);
-        if (!icon.isNull())
-            m_pWarningIcon->setPixmap(icon.pixmap(16, 16));
+        {
+            /* Confifure warning-icon: */
+            m_pWarningIcon->hide();
+            QIcon icon = UIIconPool::defaultIcon(UIIconPool::UIDefaultIconType_MessageBoxWarning, this);
+            if (!icon.isNull())
+                m_pWarningIcon->setPixmap(icon.pixmap(16, 16));
+            /* Add warning-icon to main-layout: */
+            m_pMainLayout->addWidget(m_pWarningIcon);
+        }
 
         /* Create warning-label: */
         m_pWarningLabel = new QLabel(this);
         AssertPtrReturnVoid(m_pWarningLabel);
-        /* Prepare warning-label: */
-        m_pWarningLabel->hide();
+        {
+            /* Configure warning-label: */
+            m_pWarningLabel->hide();
+            /* Prepare font: */
+#ifdef VBOX_DARWIN_USE_NATIVE_CONTROLS
+            QFont font = m_pWarningLabel->font();
+            font.setPointSize(::darwinSmallFontSize());
+            m_pWarningLabel->setFont(font);
+#endif /* VBOX_DARWIN_USE_NATIVE_CONTROLS */
+            /* Add warning-label to main-layout: */
+            m_pMainLayout->addWidget(m_pWarningLabel);
+        }
 
         /* Create spacer-item: */
         m_pSpacerItem = new QSpacerItem(0, 0, QSizePolicy::Expanding, QSizePolicy::Minimum);
         AssertPtrReturnVoid(m_pSpacerItem);
-
-        /* Prepare fonts: */
-#ifdef VBOX_DARWIN_USE_NATIVE_CONTROLS
-        QFont font = m_pSearchLabel->font();
-        font.setPointSize(::darwinSmallFontSize());
-        m_pSearchLabel->setFont(font);
-        m_pCaseSensitiveCheckBox->setFont(font);
-        m_pWarningLabel->setFont(font);
-#endif /* VBOX_DARWIN_USE_NATIVE_CONTROLS */
-    }
-
-    /** Prepares main-layout. */
-    void prepareMainLayout()
-    {
-        /* Create main-layout: */
-        QHBoxLayout *pMainLayout = new QHBoxLayout(this);
-        AssertPtrReturnVoid(pMainLayout);
-        {
-            /* Prepare main-layout: */
-            pMainLayout->setSpacing(5);
-            pMainLayout->setContentsMargins(0, 0, 0, 0);
-            pMainLayout->addWidget(m_pCloseButton);
-            pMainLayout->addWidget(m_pSearchLabel);
-            pMainLayout->addWidget(m_pSearchEditor);
-            pMainLayout->addWidget(m_pNextPrevButtons);
-            pMainLayout->addWidget(m_pCaseSensitiveCheckBox);
-            pMainLayout->addItem(m_pWarningSpacer);
-            pMainLayout->addWidget(m_pWarningIcon);
-            pMainLayout->addWidget(m_pWarningLabel);
-            pMainLayout->addItem(m_pSpacerItem);
+        {
+            /* Add spacer-item to main-layout: */
+            m_pMainLayout->addItem(m_pSpacerItem);
         }
     }
@@ -217,4 +255,5 @@
     void prepareConnections()
     {
+        /* Prepare connections: */
         connect(m_pCloseButton, SIGNAL(clicked()), this, SLOT(hide()));
         connect(m_pSearchEditor, SIGNAL(textChanged(const QString &)),
@@ -344,6 +383,6 @@
 
     /** Search routine.
-      * @a fForward specifies the direction of search.
-      * @a fStartCurrent specifies if the search should start from beginning of log. */
+      * @param  fForward       Specifies the direction of search.
+      * @param  fStartCurrent  Specifies whether search should start from beginning of the log. */
     void search(bool fForward, bool fStartCurrent = false)
     {
@@ -411,4 +450,6 @@
     /** Holds the reference to the VM Log-Viewer this search-panel belongs to. */
     UIVMLogViewer *m_pViewer;
+    /** Holds the instance of main-layout we create. */
+    QHBoxLayout *m_pMainLayout;
     /** Holds the instance of close-button we create. */
     UIMiniCancelButton *m_pCloseButton;
@@ -440,8 +481,9 @@
 
     /** Constructs the filter-panel by passing @a pParent to the QWidget base-class constructor.
-      * @a pViewer specifies the reference to the VM Log-Viewer this filter-panel belongs to. */
+      * @param  pViewer  Specifies reference to the VM Log-Viewer this filter-panel belongs to. */
     UIVMLogViewerFilterPanel(QWidget *pParent, UIVMLogViewer *pViewer)
         : QIWithRetranslateUI<QWidget>(pParent)
         , m_pViewer(pViewer)
+        , m_pMainLayout(0)
         , m_pCloseButton(0)
         , m_pFilterLabel(0), m_pFilterComboBox(0)
@@ -454,5 +496,5 @@
 
     /** Applies filter settings and filters the current log-page.
-      * @a iCurrentIndex specifies index of current log-page, but it is actually not used in the method. */
+      * @param  iCurrentIndex  Specifies index of current log-page, but it is actually not used in the method. */
     void applyFilter(const int iCurrentIndex = 0)
     {
@@ -510,10 +552,10 @@
     void prepare()
     {
+        /* Prepare main-layout: */
+        prepareMainLayout();
+
         /* Prepare widgets: */
         prepareWidgets();
 
-        /* Prepare main-layout: */
-        prepareMainLayout();
-
         /* Prepare connections: */
         prepareConnections();
@@ -521,4 +563,18 @@
         /* Retranslate finally: */
         retranslateUi();
+    }
+
+    /** Prepares main-layout. */
+    void prepareMainLayout()
+    {
+        /* Create main-layout: */
+        m_pMainLayout = new QHBoxLayout(this);
+        AssertPtrReturnVoid(m_pMainLayout);
+        {
+            /* Prepare main-layout: */
+            m_pMainLayout->setSpacing(5);
+            /* Not sure 0 margins are default, but just to be safe: */
+            m_pMainLayout->setContentsMargins(0, 0, 0, 0);
+        }
     }
 
@@ -529,42 +585,38 @@
         m_pCloseButton = new UIMiniCancelButton(this);
         AssertPtrReturnVoid(m_pCloseButton);
+        {
+            /* Add close-button to main-layout: */
+            m_pMainLayout->addWidget(m_pCloseButton);
+        }
 
         /* Create filter-combobox: */
         m_pFilterComboBox = new QComboBox(this);
         AssertPtrReturnVoid(m_pFilterComboBox);
-        /* Prepare filter-combobox: */
-        m_pFilterComboBox->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
-        m_pFilterComboBox->setEditable(true);
-        QStringList strFilterPresets;
-        strFilterPresets << "" << "GUI" << "NAT" << "AHCI" << "VD" << "Audio" << "VUSB" << "SUP" << "PGM" << "HDA"
-                         << "HM" << "VMM" << "GIM" << "CPUM";
-        strFilterPresets.sort();
-        m_pFilterComboBox->addItems(strFilterPresets);
+        {
+            /* Configure filter-combobox: */
+            m_pFilterComboBox->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
+            m_pFilterComboBox->setEditable(true);
+            QStringList strFilterPresets;
+            strFilterPresets << "" << "GUI" << "NAT" << "AHCI" << "VD" << "Audio" << "VUSB" << "SUP" << "PGM" << "HDA"
+                             << "HM" << "VMM" << "GIM" << "CPUM";
+            strFilterPresets.sort();
+            m_pFilterComboBox->addItems(strFilterPresets);
+            /* Add filter-combobox to main-layout: */
+            m_pMainLayout->addWidget(m_pFilterComboBox);
+        }
 
         /* Create filter-label: */
         m_pFilterLabel = new QLabel(this);
         AssertPtrReturnVoid(m_pFilterLabel);
-        /* Prepare filter-label: */
-        m_pFilterLabel->setBuddy(m_pFilterComboBox);
+        {
+            /* Configure filter-label: */
+            m_pFilterLabel->setBuddy(m_pFilterComboBox);
 #ifdef VBOX_DARWIN_USE_NATIVE_CONTROLS
-        QFont font = m_pFilterLabel->font();
-        font.setPointSize(::darwinSmallFontSize());
-        m_pFilterLabel->setFont(font);
+            QFont font = m_pFilterLabel->font();
+            font.setPointSize(::darwinSmallFontSize());
+            m_pFilterLabel->setFont(font);
 #endif /* VBOX_DARWIN_USE_NATIVE_CONTROLS */
-    }
-
-    /** Prepares main-layout. */
-    void prepareMainLayout()
-    {
-        /* Create main-layout: */
-        QHBoxLayout *pMainLayout = new QHBoxLayout(this);
-        AssertPtrReturnVoid(pMainLayout);
-        {
-            /* Prepare main-layout: */
-            pMainLayout->setSpacing(5);
-            pMainLayout->setContentsMargins(0, 0, 0, 0);
-            pMainLayout->addWidget(m_pCloseButton);
-            pMainLayout->addWidget(m_pFilterLabel);
-            pMainLayout->addWidget(m_pFilterComboBox);
+            /* Add filter-label to main-layout: */
+            m_pMainLayout->addWidget(m_pFilterLabel);
         }
     }
@@ -573,4 +625,5 @@
     void prepareConnections()
     {
+        /* Prepare connections: */
         connect(m_pCloseButton, SIGNAL(clicked()), this, SLOT(hide()));
         connect(m_pFilterComboBox, SIGNAL(editTextChanged(const QString &)),
@@ -637,4 +690,6 @@
     /** Holds the reference to VM Log-Viewer this filter-panel belongs to. */
     UIVMLogViewer *m_pViewer;
+    /** Holds the instance of main-layout we create. */
+    QHBoxLayout *m_pMainLayout;
     /** Holds the instance of close-button we create. */
     UIMiniCancelButton *m_pCloseButton;
@@ -652,11 +707,15 @@
 void UIVMLogViewer::showLogViewerFor(QWidget *pCenterWidget, const CMachine &machine)
 {
-    /* If there is no corresponding VM Log Viewer created: */
+    /* If there is no corresponding VM Log-Viewer created: */
     if (!m_viewers.contains(machine.GetName()))
     {
-        /* Creating new VM Log Viewer: */
+        /* Create new VM Log-Viewer: */
         UIVMLogViewer *pLogViewer = new UIVMLogViewer(pCenterWidget, Qt::Window, machine);
-        pLogViewer->setAttribute(Qt::WA_DeleteOnClose);
-        m_viewers[machine.GetName()] = pLogViewer;
+        AssertPtrReturnVoid(pLogViewer);
+        {
+            /* Configure VM Log-Viewer: */
+            pLogViewer->setAttribute(Qt::WA_DeleteOnClose);
+            m_viewers[machine.GetName()] = pLogViewer;
+        }
     }
 
@@ -686,4 +745,5 @@
 void UIVMLogViewer::search()
 {
+    /* Show/hide search-panel: */
     m_pSearchPanel->isHidden() ? m_pSearchPanel->show() : m_pSearchPanel->hide();
 }
@@ -784,5 +844,9 @@
 bool UIVMLogViewer::close()
 {
+    /* Close search-panel: */
     m_pSearchPanel->hide();
+    /* Close filter-panel: */
+    m_pFilterPanel->hide();
+    /* Call to base-class: */
     return QMainWindow::close();
 }
@@ -818,4 +882,5 @@
 void UIVMLogViewer::filter()
 {
+    /* Show/hide filter-panel: */
     m_pFilterPanel->isHidden() ? m_pFilterPanel->show() : m_pFilterPanel->hide();
 }
@@ -850,36 +915,47 @@
     m_pViewerContainer = new QITabWidget(centralWidget());
     AssertPtrReturnVoid(m_pViewerContainer);
-    /* Layout VM Log-Viewer container: */
-    m_pMainLayout->insertWidget(0, m_pViewerContainer);
+    {
+        /* Layout VM Log-Viewer container: */
+        m_pMainLayout->insertWidget(0, m_pViewerContainer);
+    }
 
     /* Create VM Log-Viewer search-panel: */
     m_pSearchPanel = new UIVMLogViewerSearchPanel(centralWidget(), this);
     AssertPtrReturnVoid(m_pSearchPanel);
-    /* Prepare VM Log-Viewer search-panel: */
-    centralWidget()->installEventFilter(m_pSearchPanel);
-    m_pSearchPanel->hide();
-    /* Layout VM Log-Viewer search-panel: */
-    m_pMainLayout->insertWidget(1, m_pSearchPanel);
+    {
+        /* Configure VM Log-Viewer search-panel: */
+        centralWidget()->installEventFilter(m_pSearchPanel);
+        m_pSearchPanel->hide();
+        /* Layout VM Log-Viewer search-panel: */
+        m_pMainLayout->insertWidget(1, m_pSearchPanel);
+    }
 
     /* Create VM Log-Viewer filter-panel: */
     m_pFilterPanel = new UIVMLogViewerFilterPanel(centralWidget(), this);
     AssertPtrReturnVoid(m_pFilterPanel);
-    /* Prepare VM Log-Viewer filter-panel: */
-    centralWidget()->installEventFilter(m_pFilterPanel);
-    m_pFilterPanel->hide();
-    /* Layout VM Log-Viewer filter-panel: */
-    m_pMainLayout->insertWidget(2, m_pFilterPanel);
-
-    /* Create/Prepare standard buttons from button-box: */
+    {
+        /* Configure VM Log-Viewer filter-panel: */
+        centralWidget()->installEventFilter(m_pFilterPanel);
+        m_pFilterPanel->hide();
+        /* Layout VM Log-Viewer filter-panel: */
+        m_pMainLayout->insertWidget(2, m_pFilterPanel);
+    }
+
+    /* Get help-button: */
     m_pButtonHelp = m_pButtonBox->button(QDialogButtonBox::Help);
     AssertPtrReturnVoid(m_pButtonHelp);
+    /* Create find-button: */
     m_pButtonFind = m_pButtonBox->addButton(QString::null, QDialogButtonBox::ActionRole);
     AssertPtrReturnVoid(m_pButtonFind);
+    /* Create filter-button: */
     m_pButtonFilter = m_pButtonBox->addButton(QString::null, QDialogButtonBox::ActionRole);
     AssertPtrReturnVoid(m_pButtonFilter);
+    /* Create close-button: */
     m_pButtonClose = m_pButtonBox->button(QDialogButtonBox::Close);
     AssertPtrReturnVoid(m_pButtonClose);
+    /* Create save-button: */
     m_pButtonSave = m_pButtonBox->button(QDialogButtonBox::Save);
     AssertPtrReturnVoid(m_pButtonSave);
+    /* Create refresh-button: */
     m_pButtonRefresh = m_pButtonBox->addButton(QString::null, QDialogButtonBox::ActionRole);
     AssertPtrReturnVoid(m_pButtonRefresh);
@@ -910,4 +986,5 @@
     }
 
+    /* Remove log-viewer: */
     if (!m_machine.isNull())
         m_viewers.remove(m_machine.GetName());
@@ -1004,19 +1081,32 @@
 QTextEdit* UIVMLogViewer::createLogPage(const QString &strName)
 {
+    /* Create page-container: */
     QWidget *pPageContainer = new QWidget;
-    QVBoxLayout *pPageLayout = new QVBoxLayout(pPageContainer);
-    QTextEdit *pLogViewer = new QTextEdit(pPageContainer);
-    pPageLayout->addWidget(pLogViewer);
-    pPageLayout->setContentsMargins(10, 10, 10, 10);
-
-    QFont font = pLogViewer->currentFont();
-    font.setFamily("Courier New,courier");
-    pLogViewer->setFont(font);
-    pLogViewer->setWordWrapMode(QTextOption::NoWrap);
-    pLogViewer->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
-    pLogViewer->setReadOnly(true);
-
-    m_pViewerContainer->addTab(pPageContainer, strName);
-    return pLogViewer;
+    AssertPtrReturn(pPageContainer, 0);
+    {
+        /* Create page-layout: */
+        QVBoxLayout *pPageLayout = new QVBoxLayout(pPageContainer);
+        AssertPtrReturn(pPageLayout, 0);
+        {
+            pPageLayout->setContentsMargins(10, 10, 10, 10);
+        }
+        /* Create Log-Viewer: */
+        QTextEdit *pLogViewer = new QTextEdit(pPageContainer);
+        AssertPtrReturn(pLogViewer, 0);
+        {
+            /* Configure Log-Viewer: */
+            QFont font = pLogViewer->currentFont();
+            font.setFamily("Courier New,courier");
+            pLogViewer->setFont(font);
+            pLogViewer->setWordWrapMode(QTextOption::NoWrap);
+            pLogViewer->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
+            pLogViewer->setReadOnly(true);
+            /* Add Log-Viewer to page-layout: */
+            pPageLayout->addWidget(pLogViewer);
+        }
+        /* Add page-container to viewer-container: */
+        m_pViewerContainer->addTab(pPageContainer, strName);
+        return pLogViewer;
+    }
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/UIVMLogViewer.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/UIVMLogViewer.h	(revision 58858)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/UIVMLogViewer.h	(revision 58859)
@@ -57,5 +57,5 @@
 
     /** Static method to create/show VM Log Viewer by passing @a pParent to QWidget base-class constructor.
-      * @a machine specifies the machine for which VM Log-Viewer is requested. */
+      * @param  machine  Specifies the machine for which VM Log-Viewer is requested. */
     static void showLogViewerFor(QWidget *pParent, const CMachine &machine);
 
@@ -63,6 +63,6 @@
 
     /** Constructs the VM Log-Viewer by passing @a pParent to QWidget base-class constructor.
-      * @a flags specifies Qt window flags.
-      * @a machine specifies the machine for which VM Log-Viewer is requested. */
+      * @param  flags    Specifies Qt window flags.
+      * @param  machine  Specifies the machine for which VM Log-Viewer is requested. */
     UIVMLogViewer(QWidget *pParent, Qt::WindowFlags flags, const CMachine &machine);
     /** Destructs the VM Log-Viewer. */
@@ -130,5 +130,5 @@
     QITabWidget *m_pViewerContainer;
 
-    /** Holds the instance of search panel. */
+    /** Holds the instance of search-panel. */
     UIVMLogViewerSearchPanel *m_pSearchPanel;
 